package ch.epfl.lamp.minischeme;

abstract class Opcode(val name: String) {
  override def toString(): String = name;
}

abstract class OpcodeRRR(name: String) extends Opcode(name);
case object ADD extends OpcodeRRR("ADD");
case object SUB extends OpcodeRRR("SUB");
case object MUL extends OpcodeRRR("MUL");
case object DIV extends OpcodeRRR("DIV");
case object MOD extends OpcodeRRR("MOD");

case object ISLT extends OpcodeRRR("ISLT");
case object ISLE extends OpcodeRRR("ISLE");
case object ISEQ extends OpcodeRRR("ISEQ");
case object CMOV extends OpcodeRRR("CMOV");

case object LINT extends Opcode("LINT");

case object ALOC extends Opcode("ALOC");
abstract class OpcodeRRC(name: String) extends Opcode(name);
case object LOAD extends OpcodeRRC("LOAD");
case object STOR extends OpcodeRRC("STOR");

abstract class OpcodeR(name: String) extends Opcode(name);
case object RINT extends OpcodeR("RINT");
case object PINT extends OpcodeR("PINT");
case object RCHR extends OpcodeR("RCHR");
case object PCHR extends OpcodeR("PCHR");

case object HALT extends Opcode("HALT");
