package ch.epfl.lamp.minischeme;

abstract class SymbolLocation;
case class FrameLocation(offset: Int) extends SymbolLocation;
case class GlobalLocation(offset: Int) extends SymbolLocation;
case class FunLocation(label: Label) extends SymbolLocation;

abstract class SymbolKind;
case object PrimitiveKind extends SymbolKind;
case object GlobalKind extends SymbolKind;
case object LocalKind extends SymbolKind;

class Symbol(val name: String, val kind: SymbolKind) {
  var location: SymbolLocation = _;
  override def toString(): String = "" + kind + "(" + name + ")"
};
