;; Warning: this file is *not* meant to be used with minischeme!
;;
;; Compatibility definitions for Scheme.
;;
;; By loading this file in an R5RS Scheme system, one should then be
;; able to load and execute minischeme programs without having to
;; modify them.

'(This file does not contain minischeme code, but R5RS code!)

(define / quotient)
(define % modulo)

(define nil '())
(define print-int (lambda (i) (display (number->string i))))
(define read-int read)
(define print-char (lambda (i) (write-char (ascii->char i))))
(define %%read-char read-char)
(define read-char (lambda () (char->ascii (%%read-char))))
(define print-space (lambda () (write-char #\space)))

(define print-int-list display)
(define print-string display)

(define %%partition partition)
(define (partition p l)
  (call-with-values (lambda () (%%partition p l)) cons))

(define %%split-at split-at)
(define (split-at p l)
  (call-with-values (lambda () (%%split-at p l)) cons))

(define list1
  (lambda (e1) (cons e1 '())))
(define list2
  (lambda (e1 e2) (cons e1 (list1 e2))))
(define list3
  (lambda (e1 e2 e3) (cons e1 (list2 e2 e3))))
(define list4
  (lambda (e1 e2 e3 e4) (cons e1 (list3 e2 e3 e4))))
(define list5
  (lambda (e1 e2 e3 e4 e5) (cons e1 (list4 e2 e3 e4 e5))))
(define list6
  (lambda (e1 e2 e3 e4 e5 e6) (cons e1 (list5 e2 e3 e4 e5 e6))))
(define list7
  (lambda (e1 e2 e3 e4 e5 e6 e7) (cons e1 (list6 e2 e3 e4 e5 e6 e7))))
(define list8
  (lambda (e1 e2 e3 e4 e5 e6 e7 e8) (cons e1 (list7 e2 e3 e4 e5 e6 e7 e8))))
(define list9
  (lambda (e1 e2 e3 e4 e5 e6 e7 e8 e9) (cons e1 (list8 e2 e3 e4 e5 e6 e7 e8 e9))))

(define merge
  (lambda (l1 l2 smaller?)
    (if (null? l1)
        l2
        (if (null? l2)
            l1
            (let ((h1 (car l1)) (h2 (car l2)))
              (if (smaller? h1 h2)
                  (cons h1 (merge (cdr l1) l2 smaller?))
                  (cons h2 (merge l1 (cdr l2) smaller?))))))))

(define sort
  (lambda (l smaller?)
    (let ((len (length l)))
      (if (< len 2)
          l
          (let ((h/t (split-at l (/ len 2))))
            (merge (sort (car h/t) smaller?)
                   (sort (cdr h/t) smaller?)
                   smaller?))))))
