#ifndef LABELS_H_
#define LABELS_H_

#define MAX_USES 32

/* Represent a label that may be un-anchored. */
typedef struct _label
{
	char anchored;
	int  address;
	int  uses[MAX_USES];
	int  nuses;
} label_t;

/* Add a label, and return it. If the label already exists,
 * return the existing one. */
extern label_t*
add_label(const char* name);

/* Return the label associated to this identifier, or NULL
 * if it's not found. */
extern label_t*
get_label(const char* ident);

/* Replace all references to 'label' by the hard address passed in
 * 'addr'. */
extern void
patch_code(label_t* label, int addr);

extern label_t*
create_label();

#endif /*LABELS_H_*/
