/*
 * MiniVM project (c) LAMP 2006
 * 
 * Log related functions.
 * 
 * $Id: log.c,v 1.1 2006/03/16 15:55:26 dragos Exp $
 */

#include <stdio.h>
#include <stdarg.h>

#include "log.h"

int log_level = LOG_DEBUG;
FILE* logfile = NULL;

static char* loglevels[] = 
  {
    "ERROR",
    "INFO",
    "WARN",
    "DEBUG"
  };

int
init_log(const char* filename)
{
  logfile = fopen(filename, "w");
  if (logfile == NULL)
    {
      perror("Could not open logfile for writing");
      return FALSE;
    }
  return TRUE;
}

void
write_log(int level, const char* str, ...)
{
  if (level <= log_level)
    {
      va_list ap;
                
      fprintf(logfile, "%s - ", loglevels[level]);
      va_start(ap, str);
      vfprintf(logfile, str, ap);
      va_end(ap);
      fflush(logfile);
    }
}
